import numpy as np
import pandas as pd
from pathlib import Path
import seaborn as sb
import matplotlib.pyplot as plt
import bottleneck as bn


#adapt the following variables to your specific sweep
#put in pathway to data (csv files)
pad = "./data/*/summary.csv" 
#put in Value's of parameters used for heatmap
x_values = []
y_values = []
# Put in names of parameters
xlabel = [""]
ylabel =[""]
#put in amount of rows in heatmap
rows = 5
#scope for retrieving the data, index from end of sequence. n = first point, m= last point
n = -96
m = -1
# setting the amount of sims that have taken place, both amount of unique runs and repeats
num = 75
repitition = 3
#setting the amount of data points used for caculaitng the sliding mean.
win = 15


# the following part is code
##############################################################################
diff = abs(n-m)
unique= int(num/repitition)
#storage for data
toxin_all = np.zeros([diff,num])
time_all = np.zeros([diff,num])
max_toxin = np.zeros(unique)
toxin_storage =np.zeros([unique, repitition])

#retrieving the data from the summary.csv files and indexing each run.
for  f in Path().cwd().glob(pad):
    run_number_full = f._parts[-2]
    run_number_part1 = run_number_full[-2]
    run_number_part2= run_number_full[-1]
    index1 = int(run_number_part1)*10
    index2 = int(run_number_part2)
    index = index1+index2
    i = index-1
    file = pd.read_csv(f)
    toxin = file["toxin_N"].values[n:m] 
    time = file["time"].values[n:m] 
    toxin_all[:,i] = toxin
    time_all[:,i] = time
    


for i in range(unique):
    
    rolled1 = bn.move_mean(toxin_all[:,i], window=win, min_count=1  )
    rolled2 = bn.move_mean(toxin_all[:,i+unique], window=win, min_count=1  )
    rolled3 = bn.move_mean(toxin_all[:,i+unique*2], window=win, min_count=1  )
    max_toxin[i] = np.mean([max(rolled1) ,max(rolled2), max(rolled3)])
    toxin_storage[i,:] = (max(rolled1) ,max(rolled2), max(rolled3))

   

matrix = np.array_split(max_toxin, rows)

plt.clf()
plt.title("Parameter sweep")
heat_map = sb.heatmap(matrix, cmap="YlGn")
heat_map.set_xticklabels(x_values)
heat_map.set_yticklabels(y_values)
plt.xlabel(xlabel)
plt.ylabel(ylabel)
plt.show()

